﻿'_____________________________________________________
'           401K F U T U R E   V A L U E   C A L C U L A T O R  II
'                           Data Validation Version
'                   Adapted from Murach ASP.Net 2008

'                                    Ron Kessler
'                                 Created 2/22/09
'_____________________________________________________

'This app computes value of 401K based on input from user. This version
'contains data validation controls.

'NOTES:

'I added a column to the table and put in two required field validator controls in the cell next to each textbox.
'Look in the table style to see how I made the table larger.

'Be sure to set range validator.Display = dynamic in properties
'Add an error message to the validator controls and use the ControlToValidate property to point to
'the correct control

Option Explicit On
Option Strict On


Partial Class _Default
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        '---now fill the listbox. Be sure to set autopostback = false for the listbox

        ddlMonthlyInvestment.AutoPostBack = False

        '---turn this off so it will ignore validation errors and refresh
        btnClear.CausesValidation = False



        If Not IsPostBack Then
            Dim amt As Integer = 0
            For amt = 50 To 1000 Step 50
                ddlMonthlyInvestment.Items.Add(amt.ToString)
            Next
        End If

    End Sub

    Protected Sub btnCalculate_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnCalculate.Click


        If Page.IsValid Then
            Dim months As Integer = 0
            Dim interestRate As Decimal = 0D
            Dim monthlyInvestment As Decimal = 0D
            Dim futureValue As Decimal = 0D

            '---grab stuff from input controls
            months = CInt(txtYears.Text) * 12

            interestRate = CDec(txtInterestRate.Text) / 12 / 100

            monthlyInvestment = CDec(ddlMonthlyInvestment.SelectedValue)

            '---compute the bad news
            futureValue = ComputedValue(months, interestRate, monthlyInvestment)

            '---display in label
            lblFutureValue.Text = FormatCurrency(futureValue)

        End If
    End Sub


    Private Function ComputedValue(ByVal months As Integer, ByVal interestRate As Decimal, _
                                  ByVal monthlyInvestment As Decimal) As Decimal

        '---compute future value here
        For x As Integer = 1 To months
            ComputedValue = (ComputedValue + monthlyInvestment) * (1 + interestRate)
        Next



    End Function

    Protected Sub btnClear_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnClear.Click

        '---clear everything
        ddlMonthlyInvestment.SelectedIndex = 0

        txtInterestRate.Text = ""
        txtYears.Text = ""
        lblFutureValue.Text = ""

       
        RequiredFieldYrs.ErrorMessage = ""
        RequiredFieldRate.ErrorMessage = ""

    End Sub
End Class
